"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _util = require("util");

var _fs = _interopRequireDefault(require("fs"));

var _chalk = _interopRequireDefault(require("chalk"));

var _yesno = _interopRequireDefault(require("yesno"));

var _objectPathImmutable = require("object-path-immutable");

var _fileExists = _interopRequireDefault(require("file-exists"));

var _read = _interopRequireDefault(require("read"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const writeFile = (0, _util.promisify)(_fs.default.writeFile);
const read = (0, _util.promisify)(_read.default);

const resume = require('resume-schema/sample.resume.json');

var _default = async ({
  resumePath
}) => {
  if (await (0, _fileExists.default)(resumePath)) {
    console.log(_chalk.default.yellow('There is already a resume.json file in this directory.'));

    if (!(await (0, _yesno.default)({
      question: 'Do you want to override?'
    }))) {
      return;
    }
  }

  console.log(`This utility will generate a file at ${resumePath}.`);
  console.log('Fill out your name and email to get started, or leave the fields blank.');
  console.log('All fields are optional.\n');
  console.log('Press ^C at any time to quit.');
  const name = await read({
    prompt: 'name: '
  });
  const email = await read({
    prompt: 'email: '
  });
  const personalizedResume = Object.entries({
    name,
    email
  }).reduce((acc, [key, value]) => (0, _objectPathImmutable.set)(acc, `basics.${key}`, value), resume);
  await writeFile(resumePath, JSON.stringify(personalizedResume, undefined, 2));
  console.log(`Your resume has been created at ${resumePath}`);
  console.log('');
  console.log('To generate a formatted .html .md .txt or .pdf resume from your resume');
  console.log('type: `resume export [someFileName]` including file extension eg: `resume export myresume.html`');
  console.log('\nYou can optionally specify an available theme for html and pdf resumes using the --theme flag.');
  console.log('Example: `resume export myresume.pdf --theme even`');
  console.log('Or simply type: `resume export` and follow the prompts.');
  console.log('');
};

exports.default = _default;