"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _util = require("util");

var _zSchema = _interopRequireDefault(require("z-schema"));

var _zSchemaErrors = _interopRequireDefault(require("z-schema-errors"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const reporter = _zSchemaErrors.default.init();

const validator = new _zSchema.default();
const validate = (0, _util.promisify)((...args) => validator.validate(...args)); // maintains context

var _default = async ({
  resume,
  schema
}) => {
  try {
    return await validate(resume, schema);
  } catch (errors) {
    throw new Error(reporter.extractMessage({
      report: {
        errors
      }
    }));
  }
};

exports.default = _default;